package Guiguts::Footnotes;
use strict;
use warnings;

BEGIN {
	use Exporter();
	our ( @ISA, @EXPORT );
	@ISA    = qw(Exporter);
	@EXPORT = qw(&footnotepop &footnotefixup &getlz);
}
## Pop up a window where footnotes can be found, fixed and formatted. (heh)
sub footnotepop {
	my $textwindow = $::textwindow;
	my $top        = $::top;
	::operationadd('Footnote Fixup' );
	::viewpagenums() if ( $::lglobal{seepagenums} );
	if ( defined( $::lglobal{footpop} ) ) {
		$::lglobal{footpop}->deiconify;
		$::lglobal{footpop}->raise;
		$::lglobal{footpop}->focus;
	} else {
		$::lglobal{fncount} = '1' unless $::lglobal{fncount};
		$::lglobal{fnalpha} = '1' unless $::lglobal{fnalpha};
		$::lglobal{fnroman} = '1' unless $::lglobal{fnroman};
		$::lglobal{fnindex} = '0' unless $::lglobal{fnindex};
		$::lglobal{fntotal} = '0' unless $::lglobal{fntotal};
		$::lglobal{footpop} = $top->Toplevel;
		::initialize_popup_without_deletebinding('footpop');
		my ( $checkn, $checka, $checkr );
		$::lglobal{footpop}->title('Footnote Fixup');
		my $frame2 =
		  $::lglobal{footpop}->Frame->pack( -side => 'top', -anchor => 'n' );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				$textwindow->yview('end');
				$textwindow->see(
							   $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] )
				  if $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2];
			},
			-text  => 'See Anchor',
			-width => 14
		)->grid( -row => 1, -column => 1, -padx => 2, -pady => 4 );
		$::lglobal{footnotetotal} =
		  $frame2->Label->grid( -row => 1, -column => 2 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				footnoteshow();
			},
			-text  => 'See Footnote',
			-width => 14
		)->grid( -row => 1, -column => 3, -padx => 2, -pady => 4 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				$::lglobal{fnindex}--;
				footnoteshow();
			},
			-text  => '<--- Last FN',
			-width => 14
		)->grid( -row => 2, -column => 1 );
		$::lglobal{fnindexbrowse} = $frame2->BrowseEntry(
			-label     => 'Go to - #',
			-variable  => \$::lglobal{fnindex},
			-state     => 'readonly',
			-width     => 8,
			-listwidth => 22,
			-browsecmd => sub {
				footnoteshow();
			}
		)->grid( -row => 2, -column => 2 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				$::lglobal{fnindex}++;
				footnoteshow();
			},
			-text  => 'Next FN --->',
			-width => 14
		)->grid( -row => 2, -column => 3 );
		$::lglobal{footnotenumber} =
		  $frame2->Label(
						  -background => $::bkgcolor,
						  -relief     => 'sunken',
						  -justify    => 'center',
						  -font       => '{Times} 10',
						  -width      => 10,
		  )->grid( -row => 3, -column => 1, -padx => 2, -pady => 4 );
		$::lglobal{footnoteletter} =
		  $frame2->Label(
						  -background => $::bkgcolor,
						  -relief     => 'sunken',
						  -justify    => 'center',
						  -font       => '{Times} 10',
						  -width      => 10,
		  )->grid( -row => 3, -column => 2, -padx => 2, -pady => 4 );
		$::lglobal{footnoteroman} =
		  $frame2->Label(
						  -background => $::bkgcolor,
						  -relief     => 'sunken',
						  -justify    => 'center',
						  -font       => '{Times} 10',
						  -width      => 10,
		  )->grid( -row => 3, -column => 3, -padx => 2, -pady => 4 );
		$checkn = $frame2->Checkbutton(
			-variable => \$::lglobal{fntypen},
			-command  => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				$checka->deselect;
				$checkr->deselect;
			},
			-text  => 'All to Number',
			-width => 14
		)->grid( -row => 4, -column => 1, -padx => 2, -pady => 4 );
		$checka = $frame2->Checkbutton(
			-variable => \$::lglobal{fntypea},
			-command  => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				$checkn->deselect;
				$checkr->deselect;
			},
			-text  => 'All to Letter',
			-width => 14
		)->grid( -row => 4, -column => 2, -padx => 2, -pady => 4 );
		$checkr = $frame2->Checkbutton(
			-variable => \$::lglobal{fntyper},
			-command  => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				$checka->deselect;
				$checkn->deselect;
			},
			-text  => 'All to Roman',
			-width => 14
		)->grid( -row => 4, -column => 3, -padx => 2, -pady => 4 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				fninsertmarkers('n');
				footnoteshow();
			},
			-text  => 'Number',
			-width => 14
		)->grid( -row => 5, -column => 1, -padx => 2, -pady => 4 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				fninsertmarkers('a');
				footnoteshow();
			},
			-text  => 'Letter',
			-width => 14
		)->grid( -row => 5, -column => 2, -padx => 2, -pady => 4 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				return if ( $::lglobal{footstyle} eq 'inline' );
				fninsertmarkers('r');
				footnoteshow();
			},
			-text  => 'Roman',
			-width => 14
		)->grid( -row => 5, -column => 3, -padx => 2, -pady => 4 );
		$frame2->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { fnjoin() },
						 -text             => 'Join With Previous',
						 -width            => 14
		)->grid( -row => 6, -column => 1, -padx => 2, -pady => 4 );
		$frame2->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { footnoteadjust() },
						 -text             => 'Adjust Bounds',
						 -width            => 14
		)->grid( -row => 6, -column => 2, -padx => 2, -pady => 4 );
		$frame2->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { setanchor() },
						 -text             => 'Set Anchor',
						 -width            => 14
		)->grid( -row => 6, -column => 3, -padx => 2, -pady => 4 );
		$frame2->Checkbutton(
							  -variable => \$::lglobal{fncenter},
							  -text     => 'Center on Search'
		)->grid( -row => 7, -column => 1, -padx => 3, -pady => 4 );
		$frame2->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				$::lglobal{fnsecondpass} = 0;
				footnotefixup();
			},
			-text  => 'First Pass',
			-width => 14
		)->grid( -row => 7, -column => 2, -padx => 2, -pady => 4 );
		my $fnrb1 = $frame2->Radiobutton(
			-text        => 'Inline',
			-variable    => \$::lglobal{footstyle},
			-selectcolor => $::lglobal{checkcolor},
			-value       => 'inline',
			-command     => sub {
				$::lglobal{fnindex} = 1;
				footnoteshow();
				$::lglobal{fnmvbutton}->configure( -state => 'disabled' );
			},
		)->grid( -row => 8, -column => 1 );
		$::lglobal{fnfpbutton} =
		  $frame2->Button(
						   -activebackground => $::activecolor,
						   -command          => sub { &footnotefixup() },
						   -text             => 'Reindex',
						   -state            => 'disabled',
						   -width            => 14
		  )->grid( -row => 8, -column => 2, -padx => 2, -pady => 4 );
		my $fnrb2 = $frame2->Radiobutton(
			-text        => 'Out-of-Line',
			-variable    => \$::lglobal{footstyle},
			-selectcolor => $::lglobal{checkcolor},
			-value       => 'end',
			-command     => sub {
				$::lglobal{fnindex} = 1;
				footnoteshow();
				$::lglobal{fnmvbutton}->configure( -state => 'normal' )
				  if ( $::lglobal{fnsecondpass}
					 && ( defined $::lglobal{fnlzs} and @{ $::lglobal{fnlzs} } )
				  );
			},
		)->grid( -row => 8, -column => 3 );
		my $frame1 =
		  $::lglobal{footpop}->Frame->pack( -side => 'top', -anchor => 'n' );
		$frame1->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { setlz() },
						 -text             => 'Set LZ @ cursor',
						 -width            => 14
		)->grid( -row => 1, -column => 1, -padx => 2, -pady => 4 );
		$frame1->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { autochaptlz() },
						 -text             => 'Autoset Chap. LZ',
						 -width            => 14
		)->grid( -row => 1, -column => 2, -padx => 2, -pady => 4 );
		$frame1->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { autoendlz() },
						 -text             => 'Autoset End LZ',
						 -width            => 14
		)->grid( -row => 1, -column => 3, -padx => 2, -pady => 4 );
		$frame1->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				getlz();
				return unless $::lglobal{fnlzs} and @{ $::lglobal{fnlzs} };
				$::lglobal{zoneindex}-- unless $::lglobal{zoneindex} < 1;
				if ( $::lglobal{fnlzs}[ $::lglobal{zoneindex} ] ) {
					$textwindow->see( 'LZ' . $::lglobal{zoneindex} );
					$textwindow->tagRemove( 'highlight', '1.0', 'end' );
					$textwindow->tagAdd(
										 'highlight',
										 'LZ' . $::lglobal{zoneindex},
										 'LZ' . $::lglobal{zoneindex} . '+10c'
					);
				}
			},
			-text  => '<--- Last LZ',
			-width => 12
		)->grid( -row => 2, -column => 1, -padx => 2, -pady => 4 );
		$frame1->Button(
			-activebackground => $::activecolor,
			-command          => sub {
				getlz();
				return unless $::lglobal{fnlzs} and @{ $::lglobal{fnlzs} };
				$::lglobal{zoneindex}++
				  unless $::lglobal{zoneindex} >
					  ( ( scalar( @{ $::lglobal{fnlzs} } ) ) - 2 );
				if ( $::lglobal{fnlzs}[ $::lglobal{zoneindex} ] ) {
					$textwindow->see( 'LZ' . $::lglobal{zoneindex} );
					$textwindow->tagRemove( 'highlight', '1.0', 'end' );
					$textwindow->tagAdd(
										 'highlight',
										 'LZ' . $::lglobal{zoneindex},
										 'LZ' . $::lglobal{zoneindex} . '+10c'
					);
				}
			},
			-text  => 'Next LZ --->',
			-width => 12
		)->grid( -row => 2, -column => 3, -padx => 6, -pady => 4 );
		my $frame3 =
		  $::lglobal{footpop}->Frame->pack( -side => 'top', -anchor => 'n' );
		$frame3->Checkbutton(
							  -variable => \$::lglobal{fnsearchlimit},
							  -text     => 'Unlimited Anchor Search'
		)->grid( -row => 1, -column => 1, -padx => 3, -pady => 4 );
		$::lglobal{fnmvbutton} =
		  $frame3->Button(
						   -activebackground => $::activecolor,
						   -command          => sub { footnotemove() },
						   -text  => 'Move Footnotes To Landing Zone(s)',
						   -state => 'disabled',
						   -width => 30
		  )->grid( -row => 1, -column => 2, -padx => 3, -pady => 4 );
		my $frame4 =
		  $::lglobal{footpop}->Frame->pack( -side => 'top', -anchor => 'n' );
		$frame4->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { footnotetidy() },
						 -text             => 'Tidy Up Footnotes',
						 -width            => 18
		)->grid( -row => 1, -column => 1, -padx => 6, -pady => 4 );
		$frame4->Button(
						 -activebackground => $::activecolor,
						 -command          => sub { fnview() },
						 -text             => 'Check Footnotes',
						 -width            => 14
		)->grid( -row => 1, -column => 2, -padx => 6, -pady => 4 );
		$::lglobal{footpop}->protocol(
			'WM_DELETE_WINDOW' => sub {
				$::lglobal{footpop}->destroy;
				undef $::lglobal{footpop};
				$textwindow->tagRemove( 'footnote', '1.0', 'end' );
			}
		);
		$fnrb2->select;
		my ( $start, $end );
		$start = '1.0';
		while (1) {
			$start = $textwindow->markNext($start);
			last unless $start;
			next unless ( $start =~ /^fns/ );
			$end = $start;
			$end =~ s/^fns/fne/;
			$textwindow->tagAdd( 'footnote', $start, $end );
		}
		$::lglobal{footnotenumber}->configure( -text => $::lglobal{fncount} );
		$::lglobal{footnoteletter}
		  ->configure( -text => alpha( $::lglobal{fnalpha} ) );
		$::lglobal{footnoteroman}
		  ->configure( -text => ::roman( $::lglobal{fnroman} ) );
		$::lglobal{footnotetotal}->configure(
			   -text => "# $::lglobal{fnindex}" . "/" . "$::lglobal{fntotal}" );
		$::lglobal{fnsecondpass} = 0;
	}
}

sub footnoteshow {
	my $textwindow = $::textwindow;
	if ( $::lglobal{fnindex} < 1 ) {
		$::lglobal{fnindex} = 1;
		return;
	}
	if ( $::lglobal{fnindex} > $::lglobal{fntotal} ) {
		$::lglobal{fnindex} = $::lglobal{fntotal};
		return;
	}
	$textwindow->tagRemove( 'footnote',  '1.0', 'end' );
	$textwindow->tagRemove( 'highlight', '1.0', 'end' );
	footnoteadjust();
	my $start     = $textwindow->index("fns$::lglobal{fnindex}");
	my $end       = $textwindow->index("fne$::lglobal{fnindex}");
	my $anchor    = $textwindow->index("fna$::lglobal{fnindex}");
	my $anchorend = $textwindow->index("fnb$::lglobal{fnindex}");
	my $line      = $textwindow->index('end -1l');
	$textwindow->yview('end');

	if ( $::lglobal{fncenter} ) {
		$textwindow->see($start) if $start;
	} else {
		my $widget = $textwindow->{rtext};
		my ( $lx, $ly, $lw, $lh ) = $widget->dlineinfo($line);
		my $bottom = int(
						  (
							$widget->height -
							  2 * $widget->cget( -bd ) -
							  2 * $widget->cget( -highlightthickness )
						  ) / $lh / 2
		) - 1;
		$textwindow->see("$end-${bottom}l") if $start;
	}
	$textwindow->tagAdd( 'footnote', $start, $end ) if $start;
	$textwindow->markSet( 'insert', $start ) if $start;
	$textwindow->tagAdd( 'highlight', $anchor, $anchorend )
	  if ( ( $anchor ne $start ) && $anchorend );
	$::lglobal{footnotetotal}
	  ->configure( -text => "# $::lglobal{fnindex}/$::lglobal{fntotal}" )
	  if $::lglobal{footpop};
	::update_indicators();
}

sub fninsertmarkers {
	my $style      = shift;
	my $textwindow = $::textwindow;
	my $offset = $textwindow->search(
								'--',
								':',
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0],
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1]
	);
	if ( $::lglobal{footstyle} eq 'end' ) {
		$textwindow->delete(
						$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] . '+9c',
						$offset )
		  if $offset;
		if ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] ne
			 $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] )
		{
			$textwindow->delete(
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2],
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] );
		}
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][6] = $::lglobal{fncount}
		  if $style eq 'n';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][6] = $::lglobal{fnalpha}
		  if $style eq 'a';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][6] = $::lglobal{fnroman}
		  if $style eq 'r';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] = $style;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = $::lglobal{fncount}
		  if $style eq 'n';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] =
		  alpha( $::lglobal{fnalpha} )
		  if $style eq 'a';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] =
		  ::roman( $::lglobal{fnroman} )
		  if $style eq 'r';
		$::lglobal{fncount}++ if $style eq 'n';
		$::lglobal{fnalpha}++ if $style eq 'a';
		$::lglobal{fnroman}++ if $style eq 'r';
		footnoteadjust();
		$textwindow->insert(
						$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] . '+9c',
						' ' . $::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] );
		$textwindow->insert( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2],
				  '[' . $::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] . ']' );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] =
		  $textwindow->index(
			 $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] . ' +'
			   . (
				 length( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] ) + 2 )
			   . 'c' );
		$textwindow->markSet( "fna$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] );
		$textwindow->markSet( "fnb$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] );
		footnoteadjust();
		$::lglobal{footnotenumber}->configure( -text => $::lglobal{fncount} );
	}
}

# Join the footnote fnindex '*[Footnote:' with the previous.
sub fnjoin {
	my $textwindow = $::textwindow;
	$textwindow->tagRemove( 'footnote',  '1.0', 'end' );
	$textwindow->tagRemove( 'highlight', '1.0', 'end' );
	# Find the colon in this footnote
	my $start = $textwindow->search(
								'--',
								':',
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0],
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1]
	);
	# $end is the ending index of this footnote -1 character
	my $end = $::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] . '-1c';
	# delete '*' at end of previous footnote
	$textwindow->delete( $::lglobal{fnarray}->[ $::lglobal{fnindex} - 1 ][1] )
	  if (
		 $textwindow->get( $::lglobal{fnarray}->[ $::lglobal{fnindex} - 1 ][1] )
		 eq '*' );
    # Insert the text of this footnote at the end of the previous one 
	$textwindow->insert(
					$::lglobal{fnarray}->[ $::lglobal{fnindex} - 1 ][1] . '-1c',
					"\n" . $textwindow->get( "$start+2c", $end ) );
	footnoteadjust();
	# Delete this footnote
	$textwindow->delete( "fns$::lglobal{fnindex}-2c", "fne$::lglobal{fnindex}+1c" );
	$textwindow->delete( "fna$::lglobal{fnindex}", "fnb$::lglobal{fnindex}" );
	$textwindow->delete( "fns$::lglobal{fnindex}-1c", "fns$::lglobal{fnindex}" )
	  if ( $textwindow->get("fns$::lglobal{fnindex}-1c") eq '*' );
	$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] = '';
	$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] = '';
	footnoteadjust();
	$::lglobal{fncount}--
	  if $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'n';
	$::lglobal{fnalpha}--
	  if $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'a';
	$::lglobal{fnroman}--
	  if $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'r';
	$::lglobal{fnindex}--;
	&footnoteshow();
}

# Pop up a window showing all the footnote addresses with potential
# problems highlighted
sub fnview {
	my $top        = $::top;
	my $textwindow = $::textwindow;
	my ( %fnotes, %anchors, $ftext );
	my $allcheckspassed =1; # flag if all checks passed
	::viewpagenums() if ( $::lglobal{seepagenums} );
	if ( defined( $::lglobal{footviewpop} ) ) {
		$::lglobal{footviewpop}->deiconify;
		$::lglobal{footviewpop}->raise;
		$::lglobal{footviewpop}->focus;
	} else {
		$::lglobal{footviewpop} = $top->Toplevel( -background => $::bkgcolor );
		::initialize_popup_with_deletebinding('footviewpop');
		$::lglobal{footviewpop}->title('Footnotes');
		my $frame1 =
		  $::lglobal{footviewpop}->Frame( -background => $::bkgcolor )
		  ->pack( -side => 'top', -anchor => 'n' );
		$frame1->Label(
			  -text =>
				"Duplicate anchors.\nmore than one fn\npointing to same anchor",
			  -background => 'yellow',
		)->grid( -row => 1, -column => 1 );
		$frame1->Label(
			-text =>
"No anchor found.\npossibly missing anchor,\nmissing colon, incorrect #",
			-background => 'pink',
		)->grid( -row => 1, -column => 2 );
		$frame1->Label(
				-text => "Out of sequence.\nfn's not in same\norder as anchors",
				-background => 'cyan',
		)->grid( -row => 1, -column => 3 );
		$frame1->Label(
			-text =>
"Very long.\nfn missing its' end bracket?\n(may just be a long fn.)",
			-background => 'tan',
		)->grid( -row => 1, -column => 4 );
		my $frame2 =
		  $::lglobal{footviewpop}->Frame->pack(
												-side   => 'top',
												-anchor => 'n',
												-fill   => 'both',
												-expand => 'both'
		  );
		$ftext = $frame2->Scrolled(
									'ROText',
									-scrollbars => 'se',
									-background => $::bkgcolor,
									-font       => $::lglobal{font},
		  )->pack(
				   -anchor => 'nw',
				   -fill   => 'both',
				   -expand => 'both',
				   -padx   => 2,
				   -pady   => 2
		  );
		::drag($ftext);
		$ftext->tagConfigure( 'seq',    background => 'cyan' );
		$ftext->tagConfigure( 'dup',    background => 'yellow' );
		$ftext->tagConfigure( 'noanch', background => 'pink' );
		$ftext->tagConfigure( 'long',   background => 'tan' );
		
		
		$::lglobal{footviewpop}
		  ->eventAdd( '<<find>>' => '<Double-Button-1>', '<Return>' );
		$::lglobal{footviewpop}->bind(
			'<<find>>',
			sub {
				my ( $row, $col ) = split( /\./, $ftext->index('insert') );
				$::lglobal{fnindex} = $row;
				footnoteshow();
			}
			);
		for my $findex ( 1 .. $::lglobal{fntotal} ) {
			$ftext->insert(
							'end',
							'footnote #' 
							  . $findex
							  . '  line.column - '
							  . $::lglobal{fnarray}->[$findex][0]
							  . ",\tanchor line.column - "
							  . $::lglobal{fnarray}->[$findex][2] . "\n"
			);
			if ( $::lglobal{fnarray}->[$findex][0] eq
				 $::lglobal{fnarray}->[$findex][2] )
			{
				$ftext->tagAdd( 'noanch', 'end -2l', 'end -1l' );
				$ftext->update;
				$allcheckspassed=0;
			}
			if (
				 ( $findex > 1 )
				 && (
					  $textwindow->compare(
										 $::lglobal{fnarray}->[$findex][0], '<',
										 $::lglobal{fnarray}->[ $findex - 1 ][0]
					  )
					  || $textwindow->compare(
										 $::lglobal{fnarray}->[$findex][2], '<',
										 $::lglobal{fnarray}->[ $findex - 1 ][2]
					  )
				 )
			  )
			{
				$ftext->tagAdd( 'seq', 'end -2l', 'end -1l' );
				$ftext->update;
				$allcheckspassed=0;
			}
			if ( exists $fnotes{ $::lglobal{fnarray}->[$findex][2] } ) {
				$ftext->tagAdd( 'dup', 'end -2l', 'end -1l' );
				$ftext->update;
				$allcheckspassed=0;
			}
			if ( $::lglobal{fnarray}->[$findex][1] -
				 $::lglobal{fnarray}->[$findex][0] > 40 )
			{
				$ftext->tagAdd( 'long', 'end -2l', 'end -1l' );
				$ftext->update;
				# do not change $allcheckspassed=0;
			}
			$fnotes{ $::lglobal{fnarray}->[$findex][2] } = $findex;
		}
		if ($allcheckspassed) {
			::operationadd('Footnote check passed');
		}
		::BindMouseWheel($ftext);
	}
}

# @{$::lglobal{fnarray}} is an array of arrays
#
# $::lglobal{fnarray}->[$::lglobal{fnindex}][0] = starting index of footnote.
# $::lglobal{fnarray}->[$::lglobal{fnindex}][1] = ending index of footnote.
# $::lglobal{fnarray}->[$::lglobal{fnindex}][2] = index of footnote anchor.
# $::lglobal{fnarray}->[$::lglobal{fnindex}][3] = index of footnote anchor end.
# $::lglobal{fnarray}->[$::lglobal{fnindex}][4] = anchor label.
# $::lglobal{fnarray}->[$::lglobal{fnindex}][5] = anchor type n a r (numeric, alphabet, roman)
# $::lglobal{fnarray}->[$::lglobal{fnindex}][6] = type index
sub footnotefixup {
	my $top        = $::top;
	my $textwindow = $::textwindow;
	::viewpagenums() if ( $::lglobal{seepagenums} );
	::operationadd('Reindex footnotes') if 	$::lglobal{fnsecondpass} == 1;
	my ( $start, $end, $anchor, $pointer );
	$textwindow->markSet( 'lastfnindex', '1.0' );
	
	$start              = 1;
	$::lglobal{fncount} = '1';
	$::lglobal{fnalpha} = '1';
	$::lglobal{fnroman} = '1';
	if ( defined( $::lglobal{footviewpop} ) ) {
		::killpopup('footviewpop');
	}
	
	$::lglobal{fnindexbrowse}->delete( '0', 'end' ) if $::lglobal{footpop};
	$::lglobal{footnotenumber}->configure( -text => $::lglobal{fncount} )
	  if $::lglobal{footpop};
	$::lglobal{footnoteletter}
	  ->configure( -text => alpha( $::lglobal{fnalpha} ) )
	  if $::lglobal{footpop};
	$::lglobal{footnoteroman}
	  ->configure( -text => ::roman( $::lglobal{fnroman} ) )
	  if $::lglobal{footpop};
	$::lglobal{ftnoteindexstart} = '1.0';
	$textwindow->markSet( 'fnindex', $::lglobal{ftnoteindexstart} );
	$::lglobal{fntotal} = 0;
	$textwindow->tagRemove( 'footnote',  '1.0', 'end' );
	$textwindow->tagRemove( 'highlight', '1.0', 'end' );

	while (1) {
		$::lglobal{ftnoteindexstart} =
		  $textwindow->search( '-exact', '--', '[ Footnote', '1.0', 'end' );
		last unless $::lglobal{ftnoteindexstart};
		$textwindow->delete( "$::lglobal{ftnoteindexstart}+1c",
							 "$::lglobal{ftnoteindexstart}+2c" );
	}
	while (1) {
		$::lglobal{ftnoteindexstart} =
		  $textwindow->search( '-exact', '--', '{Footnote', '1.0', 'end' );
		last unless $::lglobal{ftnoteindexstart};
		$textwindow->delete( $::lglobal{ftnoteindexstart},
							 "$::lglobal{ftnoteindexstart}+1c" );
		$textwindow->insert( $::lglobal{ftnoteindexstart}, '[' );
	}
	# Mispelled Fotonote
	while (1) {
		$::lglobal{ftnoteindexstart} =
		  $textwindow->search( '-exact', '--', '[Fotonote', '1.0', 'end' );
		last unless $::lglobal{ftnoteindexstart};
		$textwindow->delete( "$::lglobal{ftnoteindexstart}+1c",
							 "$::lglobal{ftnoteindexstart}+9c" );
		$textwindow->insert( "$::lglobal{ftnoteindexstart}+1c", 'Footnote' );
	}
	# Mispelled Fotonoto
	while (1) {
		$::lglobal{ftnoteindexstart} =
		  $textwindow->search( '-exact', '--', '[Footnoto', '1.0', 'end' );
		last unless $::lglobal{ftnoteindexstart};
		$textwindow->delete( "$::lglobal{ftnoteindexstart}+1c",
							 "$::lglobal{ftnoteindexstart}+9c" );
		$textwindow->insert( "$::lglobal{ftnoteindexstart}+1c", 'Footnote' );
	}
	# Mispelled footnote
	while (1) {
		$::lglobal{ftnoteindexstart} =
		  $textwindow->search( '-exact', '--', '[footnote', '1.0', 'end' );
		last unless $::lglobal{ftnoteindexstart};
		$textwindow->delete( "$::lglobal{ftnoteindexstart}+1c",
							 "$::lglobal{ftnoteindexstart}+2c" );
		$textwindow->insert( "$::lglobal{ftnoteindexstart}+1c", 'F' );
	}
	$::lglobal{ftnoteindexstart} = '1.0';
	while (1) {
		( $start, $end ) = footnotefind();
		last unless $start;
		$::lglobal{fntotal}++;
		$::lglobal{fnindex} = $::lglobal{fntotal};
		( $start, $end ) = (
							 $textwindow->index("fns$::lglobal{fnindex}"),
							 $textwindow->index("fne$::lglobal{fnindex}")
		) if $::lglobal{fnsecondpass};
		$pointer = '';
		$anchor  = '';
		$textwindow->yview('end');
		$textwindow->see($start) if $start;
		$textwindow->tagAdd( 'footnote', $start, $end );
		$textwindow->markSet( 'insert', $start );
		$::lglobal{fnindexbrowse}->insert( 'end', $::lglobal{fnindex} )
		  if $::lglobal{footpop};
		$::lglobal{footnotetotal}
		  ->configure( -text => "# $::lglobal{fnindex}/$::lglobal{fntotal}" )
		  if $::lglobal{footpop};
		$pointer =
		  $textwindow->get(
							$start,
							(
							   $textwindow->search(
											 '--', ':', $start, "$start lineend"
							   )
							)
		  );
		$pointer =~ s/\[Footnote\s*//i;
		$pointer =~ s/\s*:$//;

		if ( length($pointer) > 20 ) {
			$pointer = '';
			$textwindow->insert( "$start+9c", ':' );
		}
		if ( $::lglobal{fnsearchlimit} ) {
			$anchor =
			  $textwindow->search(
								   '-backwards', '--', "[$pointer]", $start,
								   '1.0'
			  ) if $pointer;
		} else {
			$anchor =
			  $textwindow->search(
								   '-backwards', '--', "[$pointer]", $start,
								   "$start-80l"
			  ) if $pointer;
		}
		$textwindow->tagAdd( 'highlight', $anchor,
							 $anchor . '+' . ( length($pointer) + 2 ) . 'c' )
		  if $anchor;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] = $start if $start;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] = $end   if $end;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] = $start
		  unless ( $pointer && $anchor );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] = $anchor if $anchor;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] = $start
		  unless ( $pointer && $anchor );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] =
		  $textwindow->index(
						   $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] . '+'
							 . ( length($pointer) + 2 )
							 . 'c' )
		  if $anchor;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = $pointer if $pointer;

		if ($pointer) {
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] = 'n';
			if ( $pointer =~ /\p{IsAlpha}+/ ) {
				$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] = 'a';
				$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = uc($pointer);
			}
			if ( $pointer =~ /[ivxlcdm]+\./i ) {
				$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] = 'r';
				$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = uc($pointer);
			}
		} else {
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] = '';
		}
		$textwindow->markSet( "fns$::lglobal{fnindex}", $start );
		$textwindow->markSet( "fne$::lglobal{fnindex}", $end );
		$textwindow->markSet( "fna$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] );
		$textwindow->markSet( "fnb$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] );
		::update_indicators();
		$textwindow->focus;
		$::lglobal{footpop}->raise if $::lglobal{footpop};

		if ( $::lglobal{fnsecondpass} ) {
			if ( $::lglobal{footstyle} eq 'end' ) {
				$::lglobal{fnsearchlimit} = 1;
				&fninsertmarkers('n')
				  if (
					( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'n' )
					|| ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq '' )
					|| ( $::lglobal{fntypen} ) );
				&fninsertmarkers('a')
				  if (
					  ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'a' )
					  || ( $::lglobal{fntypea} ) );
				&fninsertmarkers('r')
				  if (
					  ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] eq 'r' )
					  || ( $::lglobal{fntyper} ) );
				$::lglobal{fnmvbutton}->configure( '-state' => 'normal' )
				  if ( defined $::lglobal{fnlzs} and @{ $::lglobal{fnlzs} } );
			} else {
				$textwindow->markSet( 'insert', 'fna' . $::lglobal{fnindex} );
				$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = '';
				&setanchor();
			}
		}
	}
	$::lglobal{fnindex}      = 1;
	$::lglobal{fnsecondpass} = 1;
	$::lglobal{fnfpbutton}->configure( '-state' => 'normal' )
	  if $::lglobal{footpop};
	footnoteshow();
}

sub getlz {
	my $textwindow = $::textwindow;
	my $index      = '1.0';
	my $zone       = 0;
	$::lglobal{fnlzs} = ();
	my @marks = grep( /^LZ/, $textwindow->markNames );
	for my $mark (@marks) {
		$textwindow->markUnset($mark);
	}
	while (1) {
		$index =
		  $textwindow->search( '-regex', '--', '^FOOTNOTES:$', $index, 'end' );
		last unless $index;
		push @{ $::lglobal{fnlzs} }, $index;
		$textwindow->markSet( "LZ$zone", $index );
		$index = $textwindow->index("$index +10c");
		$zone++;
	}
}

sub autochaptlz {
	my $textwindow = $::textwindow;
	$::lglobal{zoneindex} = 0;
	$::lglobal{fnlzs}     = ();
	my $char;
	while (1) {
		$char = $textwindow->get('end-2c');
		last if ( $char =~ /\S/ );
		$textwindow->delete('end-2c');
		$textwindow->update;
	}
	$textwindow->insert( 'end', "\n\n" );
	my $index = '200.0';
	while (1) {
		$index = $textwindow->search( '-regex', '--', '^$', $index, 'end' );
		last unless ($index);
		last if ( $index < '100.0' );
		if ( ( $textwindow->index("$index+1l") ) eq
			    ( $textwindow->index("$index+1c") )
			 && ( $textwindow->index("$index+2l") ) eq
			 ( $textwindow->index("$index+2c") )
			 && ( $textwindow->index("$index+3l") ) eq
			 ( $textwindow->index("$index+3c") ) )
		{
			$textwindow->markSet( 'insert', "$index+1l" );
			setlz();
			$index .= '+4l';
		} else {
			$index .= '+1l';
			next;
		}
	}
	$textwindow->see('1.0');
}

sub autoendlz {
	my $textwindow = $::textwindow;
	$textwindow->markSet( 'insert', 'end -1c' );
	setlz();
}

sub setlz {
	my $textwindow = $::textwindow;
	# Put footnotes at the end of the previous page before a chapter 
	my $markindex = $textwindow->markPrevious('insert');
	if ($textwindow->compare($markindex,'<','insert-2l')) {
		$textwindow->insert( 'insert', "FOOTNOTES:\n\n" );
	} else {
		$textwindow->insert( $markindex.'-1c', "\n\nFOOTNOTES:" );
	}
	$::lglobal{fnmvbutton}->configure( '-state' => 'normal' )
	  if ( ( $::lglobal{fnsecondpass} ) && ( $::lglobal{footstyle} eq 'end' ) );
}

sub footnotemove {
	my $textwindow = $::textwindow;
	my ( $lz, %footnotes, $zone, $index, $r, $c, $marker );
	::operationadd('Move footnotes to landing zone');
	$::lglobal{fnsecondpass} = 0;
	footnotefixup();
	autoendlz();
	getlz();
	$::lglobal{fnindex} = 1;
	foreach my $lz ( @{ $::lglobal{fnlzs} } ) {

		if ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] ) {
			while (
					$textwindow->compare(
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0],
								'<=', $lz
					)
			  )
			{
				$footnotes{$lz} .= "\n\n"
				  . $textwindow->get( "fns$::lglobal{fnindex}",
									  "fne$::lglobal{fnindex}" );
				$::lglobal{fnindex}++;
				last if $::lglobal{fnindex} > $::lglobal{fntotal};
			}
		}
	}
	$::lglobal{fnindex} = $::lglobal{fntotal};
	while ( $::lglobal{fnindex} ) {
		$textwindow->delete("fne$::lglobal{fnindex} +1c")
		  if ( $textwindow->get("fne$::lglobal{fnindex} +1c") eq "\n" );
		$textwindow->delete("fns$::lglobal{fnindex} -1c")
		  if ( $textwindow->get("fns$::lglobal{fnindex} -1c") eq "\n" );
		$textwindow->delete( "fns$::lglobal{fnindex}",
							 "fne$::lglobal{fnindex}" );
		$::lglobal{fnindex}--;
	}
	$zone = 0;
	foreach my $lz ( @{ $::lglobal{fnlzs} } ) {
		$textwindow->insert( $textwindow->index("LZ$zone +10c"),
							 $footnotes{$lz} )
		  if $footnotes{$lz};
		$footnotes{$lz} = '';
		$zone++;
	}
	$zone = 1;
	while ( $::lglobal{fnarray}->[$zone][4] ) {
		my $fna = $textwindow->index("fna$zone");
		my $fnb = $textwindow->index("fnb$zone");
		if ( $textwindow->get( "$fna -1c", $fna ) eq ' ' ) {
			$textwindow->delete( "$fna -1c", $fna );
			$fna = $textwindow->index("fna$zone -1c");
			$fnb = $textwindow->index("fnb$zone -1c");
			$textwindow->markSet( "fna$zone", $fna );
			$textwindow->markSet( "fnb$zone", $fnb );
		}
		( $r, $c ) = split /\./, $fna;
		while ( $c eq '0' ) {
			$marker = $textwindow->get( $fna, $fnb );
			$textwindow->delete( $fna, $fnb );
			$r--;
			$textwindow->insert( "$r.end", $marker );
			( $r, $c ) = split /\./, ( $textwindow->index("$r.end") );
		}
		$zone++;
	}
	@{ $::lglobal{fnlzs} }   = ();
	@{ $::lglobal{fnarray} } = ();
	$index              = '1.0';
	$::lglobal{fnindex} = 0;
	$::lglobal{fntotal} = 0;
	while (1) {
		$index =
		  $textwindow->search( '-regex', '--', 'FOOTNOTES:', $index, 'end' );
		last unless ($index);
		unless ( $textwindow->get("$index +2l") =~ /^\[/ ) {
			$textwindow->delete( $index, "$index+12c" );
		}
		$index .= '+4l';
	}
	$textwindow->markSet( 'insert', '1.0' );
	$textwindow->see('1.0');
}

sub footnoteadjust {
	my $textwindow = $::textwindow;
	my $end        = $::lglobal{fnarray}->[ $::lglobal{fnindex} ][1];
	my $start      = $::lglobal{fnarray}->[ $::lglobal{fnindex} ][0];
	my $tempsave   = $::lglobal{ftnoteindexstart};
	my $label;
	unless ( $start and $::lglobal{fnindex} ) {
		$tempsave = $::lglobal{fnindex};
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ] = ();
		my $type = $::lglobal{fnarray}->[ $::lglobal{fnindex} ][5];
		$::lglobal{fncount}-- if $type and $type eq 'n';
		$::lglobal{fnalpha}-- if $type and $type eq 'a';
		$::lglobal{fnroman}-- if $type and $type eq 'r';
		while ( $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][0] ) {
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] =
			  $textwindow->index( 'fns' . ( $::lglobal{fnindex} + 1 ) );
			$textwindow->markSet( "fns$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] );
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] =
			  $textwindow->index( 'fne' . ( $::lglobal{fnindex} + 1 ) );
			$textwindow->markSet( "fne$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] );
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] =
			  $textwindow->index( 'fna' . ( $::lglobal{fnindex} + 1 ) );
			$textwindow->markSet( "fna$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] );
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] = '';
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] =
			  $textwindow->index( 'fnb' . ( $::lglobal{fnindex} + 1 ) )
			  if $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][3];
			$textwindow->markSet( "fnb$::lglobal{fnindex}",
							   $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] )
			  if $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][3];
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] =
			  $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][4];
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][5] =
			  $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][5];
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][6] =
			  $::lglobal{fnarray}->[ $::lglobal{fnindex} + 1 ][6];
			$::lglobal{fnindex}++;
		}
		$::lglobal{footnotenumber}->configure( -text => $::lglobal{fncount} );
		$::lglobal{footnoteletter}
		  ->configure( -text => alpha( $::lglobal{fnalpha} ) );
		$::lglobal{footnoteroman}
		  ->configure( -text => ::roman( $::lglobal{fnroman} ) );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ] = ();
		$::lglobal{fnindex} = $tempsave;
		$::lglobal{fntotal}--;
		$::lglobal{footnotetotal}
		  ->configure( -text => "# $::lglobal{fnindex}/$::lglobal{fntotal}" );
		return;
	}
	$textwindow->tagRemove( 'footnote', $start, $end );
	if ( $::lglobal{fnindex} > 1 ) {
		$::lglobal{ftnoteindexstart} =
		  $::lglobal{fnarray}->[ $::lglobal{fnindex} - 1 ][1];
		$textwindow->markSet( 'fnindex', $::lglobal{ftnoteindexstart} );
	} else {
		$::lglobal{ftnoteindexstart} = '1.0';
		$textwindow->markSet( 'fnindex', $::lglobal{ftnoteindexstart} );
	}

	#print "\n$start|$end|$::lglobal{fnindex}, $::lglobal{ftnoteindexstart}\n";
	( $start, $end ) = footnotefind();
	$textwindow->markSet( "fns$::lglobal{fnindex}", $start );
	$textwindow->markSet( "fne$::lglobal{fnindex}", $end );
	$::lglobal{ftnoteindexstart} = $tempsave;
	$textwindow->markSet( 'fnindex', $::lglobal{ftnoteindexstart} );
	$textwindow->tagAdd( 'footnote', $start, $end );
	$textwindow->markSet( 'insert', $start );
	$::lglobal{footnotenumber}->configure( -text => $::lglobal{fncount} )
	  if $::lglobal{footpop};
	$::lglobal{footnoteletter}
	  ->configure( -text => alpha( $::lglobal{fnalpha} ) )
	  if $::lglobal{footpop};
	$::lglobal{footnoteroman}
	  ->configure( -text => ::roman( $::lglobal{fnroman} ) )
	  if $::lglobal{footpop};

	if ( $end eq "$start+10c" ) {
		$textwindow->bell unless $::nobell;
		return;
	}
	$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] = $start if $start;
	$::lglobal{fnarray}->[ $::lglobal{fnindex} ][1] = $end   if $end;
	$textwindow->focus;
	$::lglobal{footpop}->raise if $::lglobal{footpop};
	return ( $start, $end );
}

# Clean up footnotes in ASCII version of text. Note: destructive. Use only
# at end of editing.
sub footnotetidy {
	my $textwindow = $::textwindow;
	my ( $begin, $end, $colon );
	$::lglobal{fnsecondpass} = 0;
	footnotefixup();
	return unless $::lglobal{fntotal} > 0;
	$::lglobal{fnindex} = 1;
	while (1) {
		$begin = $textwindow->index( 'fns' . $::lglobal{fnindex} );
		$textwindow->delete( "$begin+1c", "$begin+10c" );
		$colon =
		  $textwindow->search(
							   '--', ':', $begin,
							   $textwindow->index(
												   'fne' . $::lglobal{fnindex}
							   )
		  );
		$textwindow->delete($colon) if $colon;
		$textwindow->insert( $colon, ']' ) if $colon;
		$end = $textwindow->index( 'fne' . $::lglobal{fnindex} );
		$textwindow->delete("$end-1c");
		$textwindow->tagAdd( 'sel', 'fns' . $::lglobal{fnindex}, "$end+1c" );
		::selectrewrap( $textwindow, $::lglobal{seepagenums},
						 $MAIN::scannos_highlighted, $::rwhyphenspace );
		$::lglobal{fnindex}++;
		last if $::lglobal{fnindex} > $::lglobal{fntotal};
	}
}

sub setanchor {
	my $textwindow = $::textwindow;
	my ( $index, $insert );
	$insert = $textwindow->index('insert');
	if ( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] ne
		 $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] )
	{
		$textwindow->delete( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2],
							 $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] )
		  if $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3];
	} else {
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] = $insert;
	}
	footnoteadjust();
	if ( $::lglobal{footstyle} eq 'inline' ) {
		$index = $textwindow->search(
									  ':',
									  "fns$::lglobal{fnindex}",
									  "fne$::lglobal{fnindex}"
		);
		$textwindow->delete( "fns$::lglobal{fnindex}+9c", $index ) if $index;
		footnoteadjust();
		my $fn = $textwindow->get(
								   $textwindow->index(
													 'fns' . $::lglobal{fnindex}
								   ),
								   $textwindow->index(
													 'fne' . $::lglobal{fnindex}
								   )
		);
		$textwindow->insert( $textwindow->index("fna$::lglobal{fnindex}"), $fn )
		  if $textwindow->compare(
								   $textwindow->index("fna$::lglobal{fnindex}"),
								   '>',
								   $textwindow->index("fns$::lglobal{fnindex}")
		  );
		$textwindow->delete( $textwindow->index("fns$::lglobal{fnindex}"),
							 $textwindow->index("fne$::lglobal{fnindex}") );
		$textwindow->insert( $textwindow->index("fna$::lglobal{fnindex}"), $fn )
		  if $textwindow->compare(
								   $textwindow->index("fna$::lglobal{fnindex}"),
								   '<=',
								   $textwindow->index("fns$::lglobal{fnindex}")
		  );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0] =
		  $textwindow->index( 'fns' . $::lglobal{fnindex} );
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] = '';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] = '';
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][6] = '';
		footnoteadjust();
	} else {
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] = $insert;
		if (
			 $textwindow->compare(
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2],
								'>',
								$::lglobal{fnarray}->[ $::lglobal{fnindex} ][0]
			 )
		  )
		{
			$::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] =
			  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][0];
		}
		$textwindow->insert( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2],
				  '[' . $::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] . ']' );
		$textwindow->update;
		$::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] =
		  $textwindow->index(
			 $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] . '+'
			   . (
				 length( $::lglobal{fnarray}->[ $::lglobal{fnindex} ][4] ) + 2 )
			   . 'c' );
		$textwindow->markSet( "fna$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][2] );
		$textwindow->markSet( "fnb$::lglobal{fnindex}",
							  $::lglobal{fnarray}->[ $::lglobal{fnindex} ][3] );
		footnoteadjust();
		footnoteshow();
	}
}

sub footnotefind {
	my $textwindow = $::textwindow;
	my ( $bracketndx, $nextbracketndx, $bracketstartndx, $bracketendndx );
	$::lglobal{ftnoteindexstart} = $textwindow->index('fnindex');
	$bracketstartndx =
	  $textwindow->search( '-regexp', '--', '\[[Ff][Oo][Oo][Tt]',
						   $::lglobal{ftnoteindexstart}, 'end' );
	return ( 0, 0 ) unless $bracketstartndx;
	$bracketndx = "$bracketstartndx+1c";
	while (1) {
		$bracketendndx = $textwindow->search( '--', ']', $bracketndx, 'end' );
		$bracketendndx = $textwindow->index("$bracketstartndx+9c")
		  unless $bracketendndx;
		$bracketendndx = $textwindow->index("$bracketendndx+1c")
		  if $bracketendndx;
		$nextbracketndx = $textwindow->search( '--', '[', $bracketndx, 'end' );
		if (    ($nextbracketndx)
			 && ( $textwindow->compare( $nextbracketndx, '<', $bracketendndx ) )
		  )
		{
			$bracketndx = $bracketendndx;
			next;
		}
		last;
	}
	$::lglobal{ftnoteindexstart} = "$bracketstartndx+10c";
	$textwindow->markSet( 'fnindex', $::lglobal{ftnoteindexstart} );
	my $lastfnindex = $textwindow->index('lastfnindex');
	if ($textwindow->compare($lastfnindex,'<',$bracketendndx)) {
		$textwindow->markSet( 'lastfnindex', $bracketendndx);
	}
	#print $textwindow->index('lastfnindex').":last\n";
	return ( $bracketstartndx, $bracketendndx );
}

sub alpha {
	my $label = shift;
	$label--;
	my ( $single, $double, $triple );
	$single = $label % 26;
	$double = ( int( $label / 26 ) % 26 );
	$triple = ( $label - $single - ( $double * 26 ) % 26 );
	$single = chr( 65 + $single );
	$double = chr( 65 + $double - 1 );
	$triple = chr( 65 + $triple - 1 );
	$double = '' if ( $label < 26 );
	$triple = '' if ( $label < 676 );
	return ( $triple . $double . $single );
}
1;
